package com.ruoyi.system.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.system.common.ReturnResult;
import com.ruoyi.system.domain.ActDispensing;
import com.ruoyi.system.mapper.ActSuppliesAccountMapper;
import com.ruoyi.system.service.IActSuppliesAccountService;
import com.ruoyi.system.yyinterface.VoucherUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import static com.ruoyi.system.constant.ApiConstant.YFXM_URL;

@Service
public class ActSuppliesAccountServiceImpl implements IActSuppliesAccountService {

    private Logger logger = LoggerFactory.getLogger(ActSuppliesAccountServiceImpl.class);

    @Autowired
    private ActSuppliesAccountMapper actSuppliesAccountMapper;

    @Override
    public List<ActDispensing> options(List<ActDispensing> actDispensings) {

        for (int i=0;i<actDispensings.size();i++) {
            if (actDispensings.get(i).getDepartment().equals("")||actDispensings.get(i).getDepartment()==null){
                ActDispensing actDispensing = actSuppliesAccountMapper.selectActSuppliesAccpuntByName(actDispensings.get(i).getName());
                if (actDispensing !=null){
                    actDispensings.get(i).setAccountingCode(actDispensing.getAccountingCode());
                    actDispensings.get(i).setAccountingNameA(actDispensing.getAccountingNameA()+','+actDispensing.getAccountingIdA());
                    actDispensings.get(i).setAccountingNameB(actDispensing.getAccountingNameB()+','+actDispensing.getAccountingIdB());
                    actDispensings.get(i).setAccountingNameC(actDispensing.getAccountingNameC()+','+actDispensing.getAccountingIdC());
                }
            }else {
                ActDispensing actDispensing = actSuppliesAccountMapper.selectActSuppliesAccpuntByName(actDispensings.get(i).getName() + '-' + actDispensings.get(i).getDepartment() + '-' + actDispensings.get(i).getMaterial());
                if (actDispensing !=null){
                    actDispensings.get(i).setAccountingCode(actDispensing.getAccountingCode());
                    actDispensings.get(i).setAccountingNameA(actDispensing.getAccountingNameA()+','+actDispensing.getAccountingIdA());
                    actDispensings.get(i).setAccountingNameB(actDispensing.getAccountingNameB()+','+actDispensing.getAccountingIdB());
                    actDispensings.get(i).setAccountingNameC(actDispensing.getAccountingNameC()+','+actDispensing.getAccountingIdC());
                }
            }
        }
        List<ActDispensing> actDispensing = actSuppliesAccountMapper.selectActSuppliesAccpuntByCode();
        for (int i=0;i<actDispensing.size();i++){
            actDispensing.get(i).setAccountingNameA(actDispensing.get(i).getAccountingNameA()+','+actDispensing.get(i).getAccountingIdA());
            actDispensing.get(i).setAccountingNameB(actDispensing.get(i).getAccountingNameB()+','+actDispensing.get(i).getAccountingIdB());
            actDispensing.get(i).setAccountingNameC(actDispensing.get(i).getAccountingNameC()+','+actDispensing.get(i).getAccountingIdC());
            actDispensings.add(actDispensing.get(i));
        }

        return actDispensings;
    }

    @Override
    public List<ActDispensing> getAccountFromYon(List<ActDispensing> actDispensings) {
        JSONObject httpBody = new JSONObject();
        httpBody.put("code", actDispensings.get(0).getMining());
        httpBody.put("pageIndex", 1);
        httpBody.put("pageSize", 100000);
        ReturnResult result = VoucherUtils.callVoucherQuery( httpBody , YFXM_URL);
        JSONObject resultJsonObj = (JSONObject) result.getData().get(0);
        JSONArray recordList = resultJsonObj.getJSONArray("recordList");
        logger.info("recordList : "+ recordList.toJSONString());
        Map<String, List<String>> resultMap = new LinkedHashMap<>();
        recordList.forEach(item -> {
            JSONObject object = (JSONObject) item;
            String classifyIdName = object.getString("classifyid_name");
            String name = object.getString("name");

            resultMap.computeIfAbsent(classifyIdName, k -> new ArrayList<>()).add(name);
        });


//        for (int i=0;i<actDispensings.size();i++) {
//            if (actDispensings.get(i).getDepartment().equals("")||actDispensings.get(i).getDepartment()==null){
//                if (actDispensings.get(i)!=null && actDispensings.get(i).getName() != null){
//                    String name = actDispensings.get(i).getName();
//                    for (int t = 0; t < recordList.size(); t++) {
//                        JSONObject object = recordList.getJSONObject(t);
//                        if (name.equals(object.getString("classifyid_name"))){
////                            actDispensings.get(i).setAccountingCode(object.getString());
////                            actDispensings.get(i).setAccountingNameA(object.getString());
////                            actDispensings.get(i).setAccountingNameB(object.getString());
////                            actDispensings.get(i).setAccountingNameC(object.getString());
//                        }
//                    }
//                }
//            }else {
//                ActDispensing actDispensing = actSuppliesAccountMapper.selectActSuppliesAccpuntByName(actDispensings.get(i).getName() + '-' + actDispensings.get(i).getDepartment() + '-' + actDispensings.get(i).getMaterial());
//                if (actDispensing !=null){
//                    actDispensings.get(i).setAccountingCode(actDispensing.getAccountingCode());
//                    actDispensings.get(i).setAccountingNameA(actDispensing.getAccountingNameA()+','+actDispensing.getAccountingIdA());
//                    actDispensings.get(i).setAccountingNameB(actDispensing.getAccountingNameB()+','+actDispensing.getAccountingIdB());
//                    actDispensings.get(i).setAccountingNameC(actDispensing.getAccountingNameC()+','+actDispensing.getAccountingIdC());
//                }
//            }
//        }
//        for (int i = 0; i < recordList.size(); i++) {
//            JSONObject object = recordList.getJSONObject(i);
//
//        }
        return actDispensings;
    }


}
